#! /bin/sh

# Simple interface to cl.exe, tansforming /cygdrive/... into "mixed" path.

incdir1="c:/Program Files/Microsoft Visual Studio 10.0/VC/INCLUDE"
incdir2="c:/Program Files/Microsoft Visual Studio 10.0/VC/ATLMFC/INCLUDE"
incdir3="c:/Program Files/Microsoft SDKs/Windows/v7.0A/include"

args="-isystem c:/MinGW/include -pipe -mwindows -DG__MINGW_COMPILATION -D__MSVCRT_VERSION__=0x0601 -DCONTEXT_ALL=CONTEXT_FULL "
lang=

while [ "$1" != "" ]; do
   case "$1" in
   -I*) narg=`echo $1 | sed -e s/-I//`; args="$args -I`cygpath -m -- $narg`" ;;
   -c) args="$args -c "; shift; args="$args`cygpath -m -- $1`"; if [ `echo $1 | grep -e '\.c$'` ]; then lang="-x c"; fi  ;;
   -FI*) narg=`echo $1 | sed -e s/-FI//`; args="$args -include $narg" ;;
   -Fo*) narg=`echo $1 | sed -e s/-Fo//`; args="$args -o `cygpath -m -- $narg`" ;;
   -GR) args="$args -frtti" ;;
   -D*) args="$args $1" ;;
   -U*) args="$args $1" ;;
   -O*) args="$args $1" ;;
   -*) ;;
   *) args="$args $1"; if [ `echo $1 | grep -e '\.c$'` ]; then lang="-x c"; fi ;;
   esac
   shift
done

if [ "x$lang" == "x" ]; then
args="-fpermissive $args"
fi

args="$lang $args"

echo g++ $args
g++ $args
stat=$?

if [ $stat -eq 126 ]; then
# cygwin causes spurious exit codes 126; just re-try.
   g++ $args
   stat=$?
fi

exit $stat
