#! /bin/sh

# Simple interface to LINK, tansforming -o <exe> to -out:<exe> and unix
# pathnames to windows pathnames.

dir=`dirname $0`
args=
dll=false
dllname=
lib=false
debug=
static=false

libpath="c:\Program Files\Microsoft Visual Studio 10.0\VC\LIB;c:\Program Files\Microsoft Visual Studio 10.0\VC\ATLMFC\LIB;c:\Program Files\Microsoft SDKs\Windows\v7.0A\lib"

while [ "$1" != "" ]; do
   case "$1" in
#   -o) args="$args -out:$2"
#       dll="$2"
#       shift ;;
#   -debug) args="$args $1"
#           debug=-DDEBUG;;
   -static) static=true ;;
   -DLL) args="$args -Wl,--dll -shared"; dll=true ;;
   -o) shift; dllname="$1"; args="$args -o $1" ;;
   -ignore:*) ;;
   -incremental:*) ;;
   -nologo) ;;
   -machine:*) ;;
   -nodefaultlib*) ;;
   -debug) ;;
   imagehlp.lib) args="$args -limagehlp" ;;
   Glu32.lib) args="$args -lGlu32" ;;
   glu32.lib) args="$args -lglu32" ;;
   Opengl32.lib) args="$args -lOpengl32" ;;
   opengl32.lib) args="$args -lopengl32" ;;
   advapi32.lib) args="$args -ladvapi32" ;;
   -lib:*) libname=`echo $1 | sed -e s/-lib://`; defname=`echo $libname | sed -e "s/\.lib/\.def/"`; args="$args -Wl,--out-implib,$libname -Wl,--output-def,$defname"; lib=true ;;
   *.exp) echo "Ignoring $1" ;;
   *) args="$args $1" ;;
   esac
   shift
done

if [ "$dll" != "bin/rmkdepend.exe" -a \
     "$dll" != "bin/bindexplib.exe" -a \
     "$dll" != "bin/cint.exe" -a \
     "$dll" != "bin/makecint.exe" -a \
     "$dll" != "bin/rootcint.exe" -a \
     "$dll" != "bin/rlibmap.exe" -a \
     "$dll" != "bin/genmap.exe" -a \
     "$dll" != "cint/main/cint_tmp.exe" -a \
     "$dll" != "utils/src/rootcint_tmp.exe" -a \
     "$dll" != "bin/libCint.dll" -a \
     "$dll" != "bin/libReflex.dll" -a \
     "$dll" == "`echo $dll | sed 's,^cint/,,'`" -a \
     -r base/src/precompile.o ]; then
  args="$args base/src/precompile.o"
fi

#if [ "$dll" != "" ]; then
#   $dir/makeresource.sh "$dll" \
#      && rc $debug -Iinclude -Fo"${dll}.res" "${dll}.rc" > /dev/null 2>&1
#   if [ -r "${dll}.res" ]; then
#      args="$args ${dll}.res"
#   fi
#   rm -f "${dll}.rc"
#fi

#WHICHLINK="`which cl.exe|sed 's,cl\.exe$,link.exe,'`"
#"${WHICHLINK}" $args || exit $?

if [ "x$static" == "xtrue" ]; then

echo ar rcs $args
ar rcs $args

else

if [ "x$dll" == "xtrue" -a "x$lib" == "xfalse" ]; then
	libname=`echo $dllname | sed -e "s/\.dll/\.lib/" | sed -e s/^bin/lib/`
	defname=`echo $dllname | sed -e "s/\.dll/\.def/" | sed -e s/^bin/lib/`
	args="$args -Wl,--out-implib,$libname -Wl,--output-def,$defname"
fi

if [ "x$dll" == "xtrue" ]; then
	args="-mwindows -Wl,--subsystem,windows $args"
fi

#args="-mwindows -Wl,--subsystem,windows $args"
echo g++ $args
g++ $args || exit $?

fi

#if [ "$dll" != "" -a -f $dll.manifest ]; then
#   if [ "${dll%.dll}" == "$dll" ]
#       then resourceID=1; # .exe
#       else resourceID=2  #.dll
#   fi
#   mt -nologo -manifest $dll.manifest -outputresource:${dll}\;$resourceID
#   rm $dll.manifest
#fi

#if [ "$dll" != "" ]; then
	#rm -f "${dll}.res"
#fi

exit 0
